## ros-melodic-fuse-models 0.4.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0.2)
project(fuse_models)

find_package(
  catkin REQUIRED
  COMPONENTS
    fuse_constraints
    fuse_core
    fuse_graphs
    fuse_msgs
    fuse_publishers
    fuse_variables
    geometry_msgs
    message_generation
    nav_msgs
    pluginlib
    roscpp
    roslint
    sensor_msgs
    std_srvs
    tf2
    tf2_2d
    tf2_geometry_msgs
    tf2_ros)

find_package(Ceres REQUIRED)
find_package(Eigen3 REQUIRED)
find_package(Boost REQUIRED)

# Generate messages
add_service_files(
  DIRECTORY
    srv
  FILES
    SetGraph.srv
    SetPose.srv
    SetPoseDeprecated.srv
)

generate_messages(
  DEPENDENCIES
    geometry_msgs
    fuse_msgs
    std_msgs
)

catkin_package(
  INCLUDE_DIRS
    include
  LIBRARIES
    ${PROJECT_NAME}
  CATKIN_DEPENDS
    fuse_constraints
    fuse_core
    fuse_graphs
    fuse_msgs
    fuse_publishers
    fuse_variables
    geometry_msgs
    message_runtime
    nav_msgs
    pluginlib
    roscpp
    sensor_msgs
    std_srvs
    tf2
    tf2_2d
    tf2_geometry_msgs
    tf2_ros
  DEPENDS
    Boost
    CERES
    EIGEN3
)

set(ROSLINT_CPP_OPTS "--filter=-build/c++11,-runtime/references")
roslint_cpp()

###########
## Build ##
###########
add_compile_options(-Wall -Werror)

## Declare a C++ library
add_library(${PROJECT_NAME}
  src/acceleration_2d.cpp
  src/graph_ignition.cpp
  src/imu_2d.cpp
  src/odometry_2d.cpp
  src/odometry_2d_publisher.cpp
  src/pose_2d.cpp
  src/transaction.cpp
  src/twist_2d.cpp
  src/unicycle_2d.cpp
  src/unicycle_2d_ignition.cpp
  src/unicycle_2d_state_kinematic_constraint.cpp
)
add_dependencies(${PROJECT_NAME}
  ${${PROJECT_NAME}_EXPORTED_TARGETS}
  ${catkin_EXPORTED_TARGETS}
)
target_include_directories(${PROJECT_NAME}
  PUBLIC
    include
    ${Boost_INCLUDE_DIRS}
    ${catkin_INCLUDE_DIRS}
    ${CERES_INCLUDE_DIRS}
    ${EIGEN3_INCLUDE_DIRS}
)
target_link_libraries(${PROJECT_NAME}
  ${catkin_LIBRARIES}
  ${CERES_LIBRARIES}
)
set_target_properties(${PROJECT_NAME}
  PROPERTIES
    CXX_STANDARD 14
    CXX_STANDARD_REQUIRED YES
)

#############
## Install ##
#############

## Mark executables and/or libraries for installation
install(
  TARGETS
    ${PROJECT_NAME}
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

## Mark cpp header files for installation
install(
  DIRECTORY
    include/${PROJECT_NAME}/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
  FILES_MATCHING PATTERN "*.h"
)

install(
  FILES fuse_plugins.xml
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
)

#############
## Testing ##
#############

if(CATKIN_ENABLE_TESTING)
  find_package(rostest REQUIRED)

  # Lint tests
  roslint_add_test()

  # Model tests
  catkin_add_gtest(test_unicycle_2d
    test/test_unicycle_2d.cpp
  )
  target_link_libraries(test_unicycle_2d
    ${PROJECT_NAME}
    ${catkin_LIBRARIES}
    ${CERES_LIBRARIES}
  )
  set_target_properties(test_unicycle_2d
    PROPERTIES
      CXX_STANDARD 14
      CXX_STANDARD_REQUIRED YES
  )

  # Prediction tests
  catkin_add_gtest(
    test_unicycle_2d_predict
    test/test_unicycle_2d_predict.cpp
  )
  target_link_libraries(test_unicycle_2d_predict
    ${PROJECT_NAME}
    ${catkin_LIBRARIES}
    ${CERES_LIBRARIES}
  )
  set_target_properties(test_unicycle_2d_predict
    PROPERTIES
      CXX_STANDARD 14
      CXX_STANDARD_REQUIRED YES
  )

  # Cost function tests
  catkin_add_gtest(
    test_unicycle_2d_state_cost_function
    test/test_unicycle_2d_state_cost_function.cpp
  )
  target_link_libraries(
    test_unicycle_2d_state_cost_function
    ${PROJECT_NAME}
    ${catkin_LIBRARIES}
    ${CERES_LIBRARIES}
  )
  set_target_properties(test_unicycle_2d_state_cost_function
    PROPERTIES
      CXX_STANDARD 14
      CXX_STANDARD_REQUIRED YES
  )

  # Graph Ignition tests
  add_rostest_gtest(
    test_graph_ignition
    test/graph_ignition.test
    test/test_graph_ignition.cpp
  )
  add_dependencies(test_graph_ignition
    ${${PROJECT_NAME}_EXPORTED_TARGETS}
    ${catkin_EXPORTED_TARGETS}
  )
  target_include_directories(test_graph_ignition
    PRIVATE
      include
      ${catkin_INCLUDE_DIRS}
      ${CMAKE_CURRENT_SOURCE_DIR}
  )
  target_link_libraries(test_graph_ignition
    ${PROJECT_NAME}
    ${catkin_LIBRARIES}
  )
  set_target_properties(test_graph_ignition
    PROPERTIES
      CXX_STANDARD 14
      CXX_STANDARD_REQUIRED YES
  )

  # Unicycle2D Ignition tests
  add_rostest_gtest(
    test_unicycle_2d_ignition
    test/unicycle_2d_ignition.test
    test/test_unicycle_2d_ignition.cpp
  )
  target_link_libraries(test_unicycle_2d_ignition
    ${PROJECT_NAME}
    ${catkin_LIBRARIES}
  )
  set_target_properties(test_unicycle_2d_ignition
    PROPERTIES
      CXX_STANDARD 14
      CXX_STANDARD_REQUIRED YES
  )

  # Other tests
  catkin_add_gmock(
    test_sensor_proc
    test/test_sensor_proc.cpp
  )
  target_link_libraries(test_sensor_proc
    ${PROJECT_NAME}
    ${catkin_LIBRARIES}
  )
  set_target_properties(test_sensor_proc
    PROPERTIES
      CXX_STANDARD 14
      CXX_STANDARD_REQUIRED YES
  )

  # Benchmarks
  find_package(benchmark QUIET)

  if(benchmark_FOUND)
    add_executable(benchmark_unicycle_2d_state_cost_function
      benchmark/benchmark_unicycle_2d_state_cost_function.cpp
    )
    if(TARGET benchmark_unicycle_2d_state_cost_function)
      target_link_libraries(
        benchmark_unicycle_2d_state_cost_function
        benchmark
        ${PROJECT_NAME}
        ${catkin_LIBRARIES}
        ${CERES_LIBRARIES}
      )
      set_target_properties(benchmark_unicycle_2d_state_cost_function
        PROPERTIES
          CXX_STANDARD 14
          CXX_STANDARD_REQUIRED YES
      )
    endif()
  endif()
endif()

=== debian/changelog ===
ros-melodic-fuse-models (0.4.2-1bionic) bionic; urgency=high

  * Adding roslint dependency to fuse_viz (#231 <https://github.com/locusrobotics/fuse/issues/231>)
    * Adding roslint dependency to fuse_viz
    * Silence CMP0048 warnings
  * Contributors: Tom Moore

 -- Tom Moore <tmoore@locusrobotics.com>  Mon, 19 Jul 2021 23:00:00 -0000

ros-melodic-fuse-models (0.4.1-1bionic) bionic; urgency=high

  * Getting versions in sync
  * Substract minimum twist covariance from twist covariance (#222 <https://github.com/locusrobotics/fuse/issues/222>)
    * Substract min twist cov from twist cov
    If the twist covariance already had a minimum twist covariance added to
    it to prevent ill-conditioned covariance matrices, we need a way to
    substract that minimum twist covariance from it before we compute the
    pose relative covariance. Otherwise, we cannot get the original pose
    relative covariance because the minimum twist covariance term is
    multiplies by the time delta, which could actually make the resulting
    pose relative covariance ill-conditioned or very small, i.e.
    overconfident.
  * [Issue #223 <https://github.com/locusrobotics/fuse/issues/223>] Add an optional tf_timeout parameter to the sensor models (#224 <https://github.com/locusrobotics/fuse/issues/224>)
  * Factorize differential mode processing (#219 <https://github.com/locusrobotics/fuse/issues/219>)
    * Factorize differential mode processing
    * Throttle log message when transform message fails
  * Target frame optional (#217 <https://github.com/locusrobotics/fuse/issues/217>)
    * Make target_frame optional
    * Remove optional target_frame parameters in tests
  * Transform message in differential mode (#216 <https://github.com/locusrobotics/fuse/issues/216>)
    * Transform message in differential mode
    This is important because the relative transformation is not the same if
    the sensor and target frame are different.
    Consider for example the case of an IMU sensor upside down:
    * The robot base frame is base_link
    * The IMU sensor frame is imu_link
    * The imu_link transformation wrt base_link is 180 degrees wrt the y or
    x axis
    * The angular velocity around the z axis has opposite sign in the
    sensor frame wrt the target frame
    * Require pose_target_frame in differential mode
    * Roslint
    * Add pose_target_frame to optimizer test config
  * Use fuse_core::getPositiveParam for all ros::Duration parameters (#212 <https://github.com/locusrobotics/fuse/issues/212>)
    * Use fuse_core::getPositiveParam for ros::Duration
    * Use fuse_core::getPositiveParam for TF durations
  * Add tcp_no_delay parameter to sensor models (#211 <https://github.com/locusrobotics/fuse/issues/211>)
  * Add ability to throttle covariance computation (#209 <https://github.com/locusrobotics/fuse/issues/209>)
  * Add invert_tf to Odometry2DPublisher (#206 <https://github.com/locusrobotics/fuse/issues/206>)
    This allows to publish the inverse TF transform.
    This can be useful to skip the odom->base_link lookupTransform() when
    braodcasting map->base_link, which must be broadcasted as map->odom
    because TF tree doesn't support more than a single parent per frame,
    base_link in this case. This is particular relevant when
    predict_to_current_time is enabled, because the lookupTransform() could
    take a while, causing delays.
  * Support throttling serialized graph publisher (#204 <https://github.com/locusrobotics/fuse/issues/204>)
    * Change sensor proc from gtest to gmock target
    * Move ThrottledCallback to fuse_core
    * Support generic callbacks in ThrottledCallback
    * Throttle graph publishing
    * Overload getPositiveParam for ros::Duration
    * Use getPositiveParam for ros::Duration parameters
  * Add linear acceleration to synchronizer (#205 <https://github.com/locusrobotics/fuse/issues/205>)
  * Use local latest_stamp in notifyCallback (#203 <https://github.com/locusrobotics/fuse/issues/203>)
  * Use dedicated spinner for publish timer callback (#201 <https://github.com/locusrobotics/fuse/issues/201>)
    * Use dedicated spinner for publishTimerCallback
    * This reduces the jitter in the output topics and TF transform stamp
    because it allows the notifyCallback and publishTimerCallback to run
    concurrently. The notifyCallback might take longer than the timer
    period sometimes, mostly because the covariance computation is an
    expensive operation.
    * There is a subtle change of behaviour with this implementation!
    Before, the publishTimerCallback overwrote the odom_output_ and
    acceleration_output_ with the predicted state. Now it does not, and
    if it gets called twice or more times consecutively, it predicts since
    the last time the state was computed and updated in the
    notifyCallback. With the notifyCallback and publishTimerCallback
    running concurrently it is not trivial to keep the previous behaviour
    efficiently, because we would have to lock the entire callbacks to
    avoid the publishTimerCallback to overwrite a new state being computed
    concurrently in the notifyCallback. That being said, the predicted
    state is likely the same in both implementation. That is, the result
    is likely the same if we use multiple steps or a single one to predict
    the last state forward to the current time.
  * Add fuse_models::GraphIgnition sensor model (#196 <https://github.com/locusrobotics/fuse/issues/196>)
  * Add fuse_models::Transaction sensor model (#195 <https://github.com/locusrobotics/fuse/issues/195>)
  * Fix Unicycle2D constructor doxygen (#198 <https://github.com/locusrobotics/fuse/issues/198>)
  * Remove deprecated ::Model models leftovers (#194 <https://github.com/locusrobotics/fuse/issues/194>)
    * Remove fuse_models::twist_2d::Model plugin declaration
    * Remove empty space in fuse_plugins.xml
    * Update ::Model names to new names in doxygen comments


=== debian/control ===
Source: ros-melodic-fuse-models
Section: misc
Priority: optional
Maintainer: Tom Moore <tmoore@locusrobotics.com>
Build-Depends: debhelper (>= 9.0.0), libbenchmark-dev, libboost-all-dev, libceres-dev, libeigen3-dev, ros-melodic-catkin, ros-melodic-fuse-constraints, ros-melodic-fuse-core, ros-melodic-fuse-graphs, ros-melodic-fuse-msgs, ros-melodic-fuse-publishers, ros-melodic-fuse-variables, ros-melodic-geometry-msgs, ros-melodic-message-generation, ros-melodic-nav-msgs, ros-melodic-pluginlib, ros-melodic-roscpp, ros-melodic-roslint, ros-melodic-rostest, ros-melodic-sensor-msgs, ros-melodic-std-srvs, ros-melodic-tf2, ros-melodic-tf2-2d, ros-melodic-tf2-geometry-msgs, ros-melodic-tf2-ros
Homepage: 
Standards-Version: 3.9.2

Package: ros-melodic-fuse-models
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libboost-all-dev, libceres-dev, libeigen3-dev, ros-melodic-fuse-constraints, ros-melodic-fuse-core, ros-melodic-fuse-graphs, ros-melodic-fuse-msgs, ros-melodic-fuse-publishers, ros-melodic-fuse-variables, ros-melodic-geometry-msgs, ros-melodic-message-runtime, ros-melodic-nav-msgs, ros-melodic-pluginlib, ros-melodic-roscpp, ros-melodic-sensor-msgs, ros-melodic-std-srvs, ros-melodic-tf2, ros-melodic-tf2-2d, ros-melodic-tf2-geometry-msgs, ros-melodic-tf2-ros
Description: fuse plugins that implement various kinematic and sensor models

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/melodic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG -O3

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/melodic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/melodic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-melodic-fuse-models//opt/ros/melodic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_install
